#include "mycol.inc"
#include "leg.inc"
#include "wingtex.inc"

#declare BODY =
composite {
// ELLIPSOID
object {
    quadric {
       <1 1 1>
       <0 0 0>
       <0 0 0>
        -1.0
    scale <1 1 1>
    scale <1  0.5  1>
    rotate <0  90  0>
   }
texture { BUGTEX }
}

// ELLIPSOID
object {
    quadric {
       <1 1 1>
       <0 0 0>
       <0 0 0>
        -1.0
    scale <1 1 1>
    scale <0.8  0.3  0.8>
    rotate <0  90  0>
    translate <0  0.004338  1.44538>
   }
texture { BUGTEX }
}

// ELLIPSOID
object {
    quadric {
       <1 1 1>
       <0 0 0>
       <0 0 0>
        -1.0
    scale <1 1 1>
    scale <0.5  0.1  0.5>
    rotate <0  90  0>
    translate <0  0  2.5>
   }
texture { BUGTEX }
}

// SPHERE
object {
 sphere {<-0.475 0 -0.675> 0.35}
texture { BUGTEX }
}

// SPHERE
object {
 sphere {<0.475 0 -0.675> 0.35}
texture { BUGTEX }
}

// CONE (beak)
object {
 intersection {
  intersection {Cone_Y
    translate < 0 -1 0 >
   }
   scale <0.1 0.5 0.1>
    scale <0.5  1.1  0.5>
    rotate <220  0  0>
    translate <0  -0.95  -1.25>
 }
 texture { color Red
           phong 1.0 phong_size 200 
           ambient 0.1 diffuse 0.3 }
}
} // end BODY

#declare RIDGE =
composite {

object {
intersection { Disk_X }
scale < 0.01 0.25 0.25>
translate <0 0.5 0>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.25 0.25>
translate <0 0.45987 0.285714>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.25 0.25>
translate <0 0.390456 0.554622>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.25 0.25>
translate <0 0.286334 0.823528>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.25 0.25>
translate <0 0.251627 1.10924>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.2 0.2>
translate <0 0.286334 1.37815>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.19 0.19>
translate <0 0.286334 1.64706>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.175 0.175>
translate <0 0.251627 1.93277>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.15 0.15>
translate <0 0.112798 2.20168>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.2 0.2>
translate <0 0.494577 -0.252101>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.175 0.175>
translate <0 0.45987 -0.453782>
texture { BUGTEX }
}

object {
intersection { Disk_X }
scale <0.01 0.15 0.15>
translate <0 0.373102 -0.605042>
texture { BUGTEX }
}

} // end RIDGE

#declare EYES =
composite {
// SPHERE
object {
 sphere {<-0.450 -0.05 -.95> 0.12} 
 texture { color Green phong_size 200 phong 1.0 specular 1.0 roughness 0.001}
}
object {
 sphere {<-0.450 -0.05 -1.0> 0.06} 
 texture { color Black phong_size 200 phong 1.0 specular 1.0 roughness 0.001}
}

// SPHERE
object {
 sphere {<0.450 -0.05 -.95> 0.12}
 texture { color Green phong_size 200 phong 1.0 specular 1.0 roughness 0.001}
}
object {
 sphere {<0.450 -0.05 -1.0> 0.06}
 texture { color Black phong_size 200 phong 1.0 specular 1.0 roughness 0.001}
}
} // end composite EYES


#declare WING =
composite {
object { 
  intersection {
    intersection {
      quadric { Cylinder_Y texture { color Gray50 } }
      plane { <0 1 0> -1 inverse } 
      plane { <0 1 0> 1 }
    } 
  }  
bounded_by { box { <-1 -1 -1> <1 1 1> } }
scale <1.5 0.01 1.0> 
translate <1.95 .3 0>
rotate <0 0 12> 
translate <0 0 .4>
texture { WINGTEX }
}
object { 
  intersection {
    intersection {
      quadric { Cylinder_Y texture { color Gray50 } }
      plane { <0 1 0> -1 inverse } 
      plane { <0 1 0> 1 }
    } 
  }  
bounded_by { box { <-1 -1 -1> <1 1 1> } }
scale <1.5 0.01 1.0> 
translate <1.95 .3 0>
rotate <0 0 10> 
translate <0 0 -.4>
texture { WINGTEX }
}
} // end WING

#declare BUGFISH =
composite {
composite { BODY }
composite { RIDGE }
composite { RIDGE rotate <0 0 12> translate <-0.1 0 0> }
composite { RIDGE rotate <0 0 -12> translate <0.1 0 0> }
composite { EYES }
composite { WING }
composite { WING rotate <0 180 0> }
composite { LEG  scale <.2 .2 .2> rotate <0 20 0> translate <0 -.3 0> }
composite { LEG  scale <.2 .2 .2> translate <0 -.3 .15> }
composite { LEG  scale <.2 .2 .2> rotate <0 -20 0> translate <0 -.3 .3> }
composite { LEG  scale <.2 .2 .2> rotate <0 160 0> translate <0 -.3 0> }
composite { LEG  scale <.2 .2 .2> rotate <0 180 0> translate <0 -.3 .15> }
composite { LEG  scale <.2 .2 .2> rotate <0 200 0> translate <0 -.3 .3> }
bounded_by { box { <-7 -10 -5> <7 5 5> } }
} // end BUGFISH

composite { BUGFISH rotate <0 30 0> translate <-48.5 294.0 -620> }
